'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _icons = require('../icons');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ICON_STYLE = {
  fontSize: 20
};

// icons
// external dependencies


var Button = (0, _recompose.pure)(function (_ref) {
  var children = _ref.children;
  var icon = _ref.icon;
  var label = _ref.label;
  var onClick = _ref.onClick;
  var _ref$style = _ref.style;
  var style = _ref$style === undefined ? {} : _ref$style;

  var Icon = _icons.icons[icon];

  return _react2.default.createElement(
    'div',
    {
      'aria-label': label,
      onClick: onClick,
      role: 'button',
      style: style
    },
    _react2.default.createElement(Icon, { style: ICON_STYLE }),
    children
  );
});

Button.propTypes = {
  children: _react.PropTypes.node,
  icon: _react.PropTypes.string,
  onClick: _react.PropTypes.func,
  style: _react.PropTypes.object
};

exports.default = Button;
module.exports = exports['default'];