'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var InformationBar = (0, _recompose.pure)(function (_ref) {
  var currentTime = _ref.currentTime;
  var duration = _ref.duration;
  var style = _ref.style;

  var currentTimeDisplay = (0, _utils.getTimeFormatFromCurrentTime)(currentTime);
  var durationDisplay = (0, _utils.getTimeFormatFromCurrentTime)(duration);

  return _react2.default.createElement(
    'div',
    {
      'aria-label': currentTimeDisplay + ' out of ' + duration + ' has passed',
      style: style
    },
    currentTimeDisplay,
    ' / ',
    durationDisplay
  );
});

// utils
// external dependencies


InformationBar.propTypes = {
  currentTime: _react.PropTypes.number,
  duration: _react.PropTypes.number
};

exports.default = InformationBar;
module.exports = exports['default'];