'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp2; // external dependencies


// components


// icons


var _elementResizeEvent = require('element-resize-event');

var _elementResizeEvent2 = _interopRequireDefault(_elementResizeEvent);

var _debounce = require('lodash/debounce');

var _debounce2 = _interopRequireDefault(_debounce);

var _isUndefined = require('lodash/isUndefined');

var _isUndefined2 = _interopRequireDefault(_isUndefined);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _recompose = require('recompose');

var _shallowEqual = require('recompose/shallowEqual');

var _shallowEqual2 = _interopRequireDefault(_shallowEqual);

var _vidz = require('vidz');

var _vidz2 = _interopRequireDefault(_vidz);

var _Button = require('./components/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Display = require('./components/Display');

var _Display2 = _interopRequireDefault(_Display);

var _InformationBar = require('./components/InformationBar');

var _InformationBar2 = _interopRequireDefault(_InformationBar);

var _Track = require('./components/Track');

var _Track2 = _interopRequireDefault(_Track);

var _TrackButton = require('./components/TrackButton');

var _TrackButton2 = _interopRequireDefault(_TrackButton);

var _VolumeContainer = require('./components/VolumeContainer');

var _VolumeContainer2 = _interopRequireDefault(_VolumeContainer);

var _icons = require('./icons');

var _utils = require('./utils');

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var THEMES = ['dark', 'light'];

var PLAYBACK_SPEEDS = [1, 2, 4, 8, 16];

var _getFullscreenPropert = (0, _utils.getFullscreenProperties)();

var exitFullscreen = _getFullscreenPropert.exitFullscreen;
var fullscreen = _getFullscreenPropert.fullscreen;
var fullscreenchange = _getFullscreenPropert.fullscreenchange;
var fullscreenEnabled = _getFullscreenPropert.fullscreenEnabled;
var requestFullscreen = _getFullscreenPropert.requestFullscreen;


var transformProperty = (0, _utils.getTransformProperty)();

var VidzPlayer = (0, _recompose.pure)(_class = (_temp2 = _class2 = function (_Component) {
  _inherits(VidzPlayer, _Component);

  function VidzPlayer() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    _classCallCheck(this, VidzPlayer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(VidzPlayer)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.state = {
      autoHideTimeout: null,
      canUseFullscreen: true,
      controlsVisible: true,
      currentTime: 0,
      duration: 0,
      isDraggingDurationTrackButton: false,
      isDraggingVolumeTrackButton: false,
      isFullscreen: false,
      isLoaded: false,
      isMuted: false,
      isPlaying: false,
      isVolumeChangeActive: false,
      playbackRateIndex: 0,
      queuedOnVolumeSet: [],
      volume: 1
    }, _this.duration = null, _this.durationTrack = null, _this.durationTrackButton = null, _this.vidzInstance = null, _this.volume = null, _this.volumeTrack = null, _this.volumeTrackButton = null, _this.debounceSetPlayerDimensionsOnResize = (0, _debounce2.default)(function () {
      var isFullscreen = _this.state.isFullscreen;


      if (isFullscreen) {
        _this.debounceSetPlayerDimensions();
      }
    }, 50), _this.debounceSetPlayerDimensions = (0, _debounce2.default)(function () {
      var dimensions = _this.getHeightAndWidth();

      _this.vidzInstance.setPlayerDimensions(dimensions);
    }, 50), _this.getHeightAndWidth = function () {
      var _this$props = _this.props;
      var heightFromProps = _this$props.height;
      var widthFromProps = _this$props.width;
      var isFullscreen = _this.state.isFullscreen;


      var width = widthFromProps;

      if (isFullscreen) {
        width = window.innerWidth;
      } else if ((0, _isUndefined2.default)(width)) {
        width = Math.round(_this.refs.container.clientWidth);
      }

      var height = heightFromProps;

      if ((0, _isUndefined2.default)(height)) {
        if (_this.vidzInstance) {
          var naturalHeight = _this.vidzInstance.player.videoHeight;
          var naturalWidth = _this.vidzInstance.player.videoWidth;
          var multiplier = _this.vidzInstance.player.width / naturalWidth;

          height = Math.round(naturalHeight * multiplier);
        } else {
          height = Math.round(width * 0.6);
        }
      }

      if (isFullscreen) {
        var maxHeight = window.innerHeight;

        if (height > maxHeight) {
          height = maxHeight;
        }
      }

      return {
        height: height,
        width: width
      };
    }, _this.onClickDurationTrack = function (e) {
      var left = _this.duration.getBoundingClientRect().left;
      var offset = e.pageX - left;
      var percentage = offset / _this.duration.clientWidth;

      _this.setDurationTrackButtonPosition(percentage, true);
    }, _this.onClickFastForward = function () {
      var _this$state = _this.state;
      var isPlaying = _this$state.isPlaying;
      var playbackRateIndex = _this$state.playbackRateIndex;


      if (isPlaying) {
        var newIndex = playbackRateIndex === PLAYBACK_SPEEDS.length - 1 ? 0 : playbackRateIndex + 1;

        _this.setState({
          playbackRateIndex: newIndex
        });

        _this.vidzInstance.setPlaybackRate(PLAYBACK_SPEEDS[newIndex]);
      }
    }, _this.onClickPlayPauseButton = function () {
      var isPlaying = _this.state.isPlaying;


      if (_this.vidzInstance.playbackRate !== 1) {
        _this.vidzInstance.setPlaybackRate(1);

        _this.setState({
          playbackRateIndex: 0
        });
      }

      if (isPlaying) {
        _this.vidzInstance.pause();
      } else {
        _this.vidzInstance.play();
      }
    }, _this.onClickToggleFullscreen = function () {
      var isFullscreen = _this.state.isFullscreen;


      if (isFullscreen) {
        document[exitFullscreen]();
      } else {
        _this.refs.container[requestFullscreen]();
      }
    }, _this.onClickToggleVolumeMuted = function () {
      var isMuted = _this.state.isMuted;


      if (isMuted) {
        _this.setState({
          isMuted: false
        });

        _this.vidzInstance.unmute();
      } else {
        _this.setState({
          isMuted: true
        });

        _this.vidzInstance.mute();
      }
    }, _this.onClickVolumeTrack = function (e) {
      var top = _this.volume.getBoundingClientRect().top;
      var offset = e.pageY - top;
      var percentage = offset / _this.volume.clientHeight;

      _this.setVolumeTrackButtonPosition(percentage, true);
    }, _this.onDragDurationTrackButton = function (e) {
      var left = _this.duration.getBoundingClientRect().left;

      var offset = e.pageX - left;

      var percentage = offset / _this.duration.clientWidth;

      if (percentage > 1) {
        percentage = 1;
      } else if (percentage < 0) {
        percentage = 0;
      }

      _this.setDurationTrackButtonPosition(percentage, true);
    }, _this.onDragVolumeTrackButton = function (e) {
      var top = _this.volumeTrack.getBoundingClientRect().top;

      var offset = e.pageY - top;

      var percentage = offset / _this.volumeTrack.clientHeight;

      if (percentage > 1) {
        percentage = 1;
      } else if (percentage < 0) {
        percentage = 0;
      }

      _this.setVolumeTrackButtonPosition(percentage, true);
    }, _this.onDragEndDurationTrackButton = function (e) {
      e.stopPropagation();
      e.preventDefault();

      _this.setState({
        isDraggingDurationTrackButton: false
      });

      window.removeEventListener('mouseup', _this.onDragEndDurationTrackButton);
      window.removeEventListener('mousemove', _this.onDragDurationTrackButton);
    }, _this.onDragEndVolumeTrackButton = function (e) {
      e.stopPropagation();
      e.preventDefault();

      var queuedOnVolumeSet = _this.state.queuedOnVolumeSet;


      _this.setState({
        isDraggingVolumeTrackButton: false
      });

      queuedOnVolumeSet.forEach(function (fn) {
        fn();
      });

      _this.setState({
        queuedOnVolumeSet: []
      });

      window.removeEventListener('mouseup', _this.onDragEndVolumeTrackButton);
      window.removeEventListener('mousemove', _this.onDragVolumeTrackButton);
    }, _this.onDragStartDurationTrackButton = function (e) {
      e.stopPropagation();
      e.preventDefault();

      _this.setState({
        isDraggingDurationTrackButton: true
      });

      window.addEventListener('mouseup', _this.onDragEndDurationTrackButton);
      window.addEventListener('mousemove', _this.onDragDurationTrackButton);
    }, _this.onDragStartVolumeTrackButton = function (e) {
      e.stopPropagation();
      e.preventDefault();

      _this.setState({
        isDraggingVolumeTrackButton: true
      });

      window.addEventListener('mouseup', _this.onDragEndVolumeTrackButton);
      window.addEventListener('mousemove', _this.onDragVolumeTrackButton);
    }, _this.onFullscreenChange = function () {
      _this.setState({
        isFullscreen: document[fullscreen]
      });

      var dimensions = _this.getHeightAndWidth();

      _this.vidzInstance.setPlayerDimensions(dimensions);
    }, _this.onLoadedMetadata = function (e, instance) {
      var onLoadedMetadata = _this.props.onLoadedMetadata;


      _this.setPercentLoaded(instance.percentLoaded);
      _this.setTimeRepresentation({
        duration: instance.duration
      });

      if (onLoadedMetadata) {
        onLoadedMetadata.call(instance, e, instance);
      }
    }, _this.onMouseEnterVolumeChange = function () {
      var queuedOnVolumeSet = _this.state.queuedOnVolumeSet;


      if (queuedOnVolumeSet.length) {
        _this.setState({
          queuedOnVolumeSet: []
        });
      }

      _this.setVolumeChangeState(true);
    }, _this.onMouseLeaveVolumeChange = function () {
      var isDraggingVolumeTrackButton = _this.state.isDraggingVolumeTrackButton;


      if (isDraggingVolumeTrackButton) {
        var queuedOnVolumeSet = [_this.setVolumeChangeState];

        _this.setState({
          queuedOnVolumeSet: queuedOnVolumeSet
        });
      } else {
        _this.setVolumeChangeState();
      }
    }, _this.setVolumeChangeState = function () {
      var isActive = arguments.length <= 0 || arguments[0] === undefined ? false : arguments[0];

      _this.setState({
        isVolumeChangeActive: isActive
      });
    }, _this.onMouseMoveContainer = function () {
      var _this$state2 = _this.state;
      var autoHideTimeout = _this$state2.autoHideTimeout;
      var controlsVisible = _this$state2.controlsVisible;
      var isPlaying = _this$state2.isPlaying;


      clearTimeout(autoHideTimeout);

      if (!controlsVisible) {
        _this.setState({
          controlsVisible: true
        });
      }

      if (isPlaying) {
        _this.setTimeoutToHideControls();
      }
    }, _this.onPause = function (e, instance) {
      var onPause = _this.props.onPause;
      var autoHideTimeout = _this.state.autoHideTimeout;


      clearTimeout(autoHideTimeout);

      _this.setState({
        controlsVisible: true,
        isPlaying: false
      });

      if (onPause) {
        onPause.call(instance, e, instance);
      }

      _this.setPercentLoaded(instance.percentLoaded);
    }, _this.onPlay = function (e, instance) {
      var onPlay = _this.props.onPlay;
      var controlsVisible = _this.state.controlsVisible;


      _this.setState({
        isPlaying: true
      });

      if (onPlay) {
        onPlay.call(instance, e, instance);
      }

      _this.setPercentLoaded(instance.percentLoaded);

      if (controlsVisible) {
        _this.setTimeoutToHideControls();
      }
    }, _this.onTimeUpdate = function (e, instance) {
      var onTimeUpdate = _this.props.onTimeUpdate;


      _this.setPercentPlayed(instance.currentTime, instance.duration);
      _this.setPercentLoaded(instance.percentLoaded);
      _this.setTimeRepresentation({
        currentTime: instance.currentTime
      });

      if (onTimeUpdate) {
        onTimeUpdate.call(instance, e, instance);
      }
    }, _this.onVolumeChange = function (e, instance) {
      var onVolumeChange = _this.props.onVolumeChange;


      var volume = _this.vidzInstance.volume;

      _this.setState({
        volume: volume
      });

      if (onVolumeChange) {
        onVolumeChange.call(instance, e, instance);
      }
    }, _this.setDurationTrackButtonPosition = function (percentage) {
      var setTime = arguments.length <= 1 || arguments[1] === undefined ? false : arguments[1];

      var marginLeft = Math.round(percentage * 12);
      var percentInPixels = Math.round(percentage * _this.duration.clientWidth);
      var left = percentInPixels - marginLeft;

      if (transformProperty) {
        _this.durationTrackButton.style.transform = 'translate3d(' + left + 'px, 0, 0)';
      } else {
        _this.durationTrackButton.style.left = left + 'px';
      }

      if (setTime) {
        _this.setTime(percentage);
      }
    }, _this.setPercentLoaded = function (percentLoaded) {
      _this.durationTrack.style.width = percentLoaded + '%';
    }, _this.setPercentPlayed = function (currentTime, duration) {
      var percentPlayed = (0, _utils.getPercentPlayed)(currentTime, duration);

      _this.setDurationTrackButtonPosition(percentPlayed / 100);
    }, _this.setTime = (0, _debounce2.default)(function (percentage) {
      _this.vidzInstance.setCurrentTime(percentage * _this.vidzInstance.duration);
    }, 50), _this.setTimeRepresentation = function (_ref) {
      var currentTime = _ref.currentTime;
      var duration = _ref.duration;

      if (!(0, _isUndefined2.default)(currentTime)) {
        _this.setState({
          currentTime: currentTime
        });
      }

      if (!(0, _isUndefined2.default)(duration)) {
        _this.setState({
          duration: duration
        });
      }
    }, _this.setTimeoutToHideControls = function () {
      var preventAutoHideControls = _this.props.preventAutoHideControls;


      if (!preventAutoHideControls) {
        var autoHideTimeout = setTimeout(function () {
          _this.setState({
            controlsVisible: false
          });
        }, 3000);

        _this.setState({
          autoHideTimeout: autoHideTimeout
        });
      }
    }, _this.setVidzInstance = function () {
      if (_this.refs.container.parentNode.clientWidth === 0) {
        _this.debounceSetPlayerDimensions();
      }

      var _this$props2 = _this.props;
      var autoplay = _this$props2.autoplay;
      var muted = _this$props2.muted;

      var _this$getHeightAndWid = _this.getHeightAndWidth();

      var height = _this$getHeightAndWid.height;
      var width = _this$getHeightAndWid.width;


      _this.vidzInstance = (0, _vidz2.default)(_this.refs.playerContainer, _extends({}, _this.props, {
        controls: false,
        height: height,
        onLoadedMetadata: _this.onLoadedMetadata,
        onPause: _this.onPause,
        onPlay: _this.onPlay,
        onTimeUpdate: _this.onTimeUpdate,
        onVolumeChange: _this.onVolumeChange,
        width: width
      }));

      _this.vidzInstance.player.style.display = 'block';

      if (autoplay) {
        _this.setState({
          isPlaying: true
        });
      }

      if (muted) {
        _this.setState({
          isMuted: true
        });
      }

      _this.setState({
        isLoaded: true
      });
    }, _this.setVolume = (0, _debounce2.default)(function (percentage) {
      _this.vidzInstance.setVolume(percentage);
    }, 50), _this.setVolumeTrackButtonPosition = function (percentage) {
      var setVolume = arguments.length <= 1 || arguments[1] === undefined ? false : arguments[1];

      var top = Math.round(percentage * _this.volumeTrack.clientHeight);

      if (transformProperty) {
        _this.volumeTrackButton.style.transform = 'translate3d(0, ' + top + 'px, 0)';
      } else {
        _this.volumeTrackButton.style.top = top + 'px';
      }

      if (setVolume) {
        _this.setVolume(1 - percentage);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(VidzPlayer, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var canUseFullscreen = document[fullscreenEnabled];

      this.setState({
        canUseFullscreen: canUseFullscreen
      });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setVidzInstance();

      (0, _elementResizeEvent2.default)(this.refs.container, this.debounceSetPlayerDimensions);

      document.addEventListener(fullscreenchange, this.onFullscreenChange);
      window.addEventListener('resize', this.debounceSetPlayerDimensionsOnResize);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(previousProps) {
      if (!(0, _shallowEqual2.default)(this.props, previousProps) || !this.state.isLoaded) {
        this.setVidzInstance();
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.removeEventListener(fullscreenchange, this.onFullscreenChange);
      window.removeEventListener('resize', this.debounceSetPlayerDimensionsOnResize);
    }

    /**
     * if in fullscreen mode, resize the player because it isn't handled by the
     * element resize
     */


    /**
     * resize the Vidz instance dimensions
     */


    /**
     * get the intended height and width
     * 
     * the width is either the explicit width passed as a prop, the width of the 
     * parent container, or if in fullscreen mode the width of the window
     * 
     * the height is either the explicit height passed as a prop or the aspect
     * ratio of the video based on its metadata (with a generic default until
     * metadata has loaded)
     * 
     * @return {{height: number, width: number}}
     */


    /**
     * set the currentTime of the video based on the location clicked
     * 
     * @param {Event} e
     */


    /**
     * increase the playback rate in increments in PLAYBACK_SPEEDS
     */


    /**
     * toggle between play and pause
     */


    /**
     * toggle between fullscreen mode and standard mode
     */


    /**
     * toggle between muted and unmuted
     */


    /**
     * set the volume based on the location clicked
     *
     * @param {Event} e
     */


    /**
     * based on where the button was dragged, calculate the percentage
     * of the total video length and jump to that time location
     *
     * @param {Event} e
     */


    /**
     * based on where the button was dragged, calculate the percentage
     * of the total volume length and apply that volume
     *
     * @param {Event} e
     */


    /**
     * when finished dragging the button, remove the listeners
     *
     * @param {Event} e
     */


    /**
     * when finished dragging the button, remove the listeners and if there
     * are functions in the queue to fire, fire them
     *
     * @param {Event} e
     */


    /**
     * when you start dragging, add listeners to update the currentTime
     * onDrag
     *
     * @param {Event} e
     */


    /**
     * when you start dragging, add listeners to update the volume
     * onDrag
     *
     * @param {Event} e
     */


    /**
     * when the fullscreen state changes, reset the dimensions of the video
     */


    /**
     * when metadata has loaded, update the percentLoaded and the
     * time displayed, and fire the function passed by props if exists
     *
     * @param {Event} e
     * @param {Vidz} instance
     */


    /**
     * show the volume bar on mouseenter
     */


    /**
     * hide the volume bar on mouseleave unless a drag is in effect,
     * else queue up the closure of it
     */


    /**
     * set the active state of the volume bar
     * 
     * @param {boolean} isActive
     */


    /**
     * when mouse movement occurs over the container, clear
     * the timeout of hiding the controls and set a new one
     */


    /**
     * on pause set the controls to be visible and the isPlaying state,
     * plus the function passed by props if it exists
     * 
     * @param {Event} e
     * @param {instance} instance
     */


    /**
     * on play set the hde controls timeout and the isPlaying state,
     * plus the function passed by props if it exists
     *
     * @param {Event} e
     * @param {instance} instance
     */


    /**
     * on time update set the currentTime and percent loaded,
     * plus the function passed by props if it exists
     *
     * @param {Event} e
     * @param {instance} instance
     */


    /**
     * on volume change set the volume in state,
     * plus the function passed by props if it exists
     *
     * @param {Event} e
     * @param {instance} instance
     */


    /**
     * update the position of the durationTrackButton,
     * and the currentTime if setTime is true
     * 
     * @param {number} percentage
     * @param {boolean} setTime=false
     */


    /**
     * update the width of the duration track with the new percent loaded
     * 
     * @param {number} percentLoaded
     */


    /**
     * set the position of the duration track button based on the percent played
     * 
     * @param {number} currentTime
     * @param {number} duration
     */


    /**
     * set the currentTime on the Vidz instance based on the percentage of the duration
     */


    /**
     * set the currentTime and duration in state so they can be reflected
     * in the visual display
     * 
     * @param {number} currentTime
     * @param {number} duration
     */


    /**
     * set the timeout to hide the controls from inactivity
     */


    /**
     * create a new Vidz instance and save it to the class' instance
     */


    /**
     * update the volume of the Vidz instance based on the percentage passed
     */


    /**
     * update the position of the volume track button based on the percentage passed,
     * and set the volume if setVolume is true
     * 
     * @param {number} percentage
     * @param {boolean} setVolume=false
     */

  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props;
      var controlsBackgroundColor = _props.controlsBackgroundColor;
      var controlsFontColor = _props.controlsFontColor;
      var playOnClick = _props.playOnClick;
      var controlsTrackColor = _props.controlsTrackColor;
      var theme = _props.theme;
      var _state = this.state;
      var canUseFullscreen = _state.canUseFullscreen;
      var controlsVisible = _state.controlsVisible;
      var currentTime = _state.currentTime;
      var duration = _state.duration;
      var isFullscreen = _state.isFullscreen;
      var isMuted = _state.isMuted;
      var isPlaying = _state.isPlaying;
      var isVolumeChangeActive = _state.isVolumeChangeActive;
      var playbackRateIndex = _state.playbackRateIndex;


      var volume = this.vidzInstance ? this.vidzInstance.volume : 1;
      var volumeIcon = (0, _utils.getVolumeIcon)(volume, isMuted);

      var styles = void 0;

      switch (theme) {
        case THEMES[1]:
          styles = _styles.lightStyles;
          break;

        default:
          styles = _styles.darkStyles;
          break;
      }

      var controlsStyle = (0, _utils.getControlsContainerStyle)(styles.controlsContainer, controlsVisible);
      var durationTrackStyle = (0, _utils.getControlStyle)(styles.durationTrack, controlsTrackColor);
      var durationTrackButtonStyle = (0, _utils.getControlStyle)(styles.durationTrackButton, controlsFontColor);
      var playPauseButtonStyle = (0, _utils.getControlStyle)(styles.playPauseButton, controlsBackgroundColor, controlsFontColor);
      var volumeButtonStyle = (0, _utils.getControlStyle)(styles.volumeButton, controlsBackgroundColor, controlsFontColor);
      var informationContainerStyle = (0, _utils.getControlStyle)(styles.informationContainer, controlsBackgroundColor, controlsFontColor);
      var fastForwardButtonStyle = (0, _utils.getControlStyle)(styles.fastForwardButton, controlsBackgroundColor, controlsFontColor);
      var fullscreenButtonStyle = (0, _utils.getControlStyle)(styles.fullscreenButton, controlsBackgroundColor, controlsFontColor);
      var volumeChangeStyle = (0, _utils.getVolumeChangeStyle)(styles.volumeChange, _styles.allStyles.volumeChangeActive, isVolumeChangeActive, controlsBackgroundColor, controlsFontColor);
      var volumeChangeTrackStyle = (0, _utils.getControlStyle)(styles.volumeChangeTrack, controlsTrackColor);
      var volumeTrackButtonStyle = (0, _utils.getControlStyle)(styles.volumeTrackButton, controlsFontColor);

      return _react2.default.createElement(
        'div',
        {
          onMouseMove: this.onMouseMoveContainer,
          ref: 'container',
          style: styles.container
        },
        _react2.default.createElement('div', {
          onClick: playOnClick && this.onClickPlayPauseButton,
          ref: 'playerContainer'
        }),
        _react2.default.createElement(
          'div',
          { style: controlsStyle },
          _react2.default.createElement(
            _Display2.default,
            {
              onClick: this.onClickDurationTrack,
              ref: function ref(component) {
                _this2.duration = (0, _reactDom.findDOMNode)(component);
              },
              style: styles.durationSlider
            },
            _react2.default.createElement(_Track2.default, {
              ref: function ref(component) {
                _this2.durationTrack = (0, _reactDom.findDOMNode)(component);
              },
              style: durationTrackStyle
            }),
            _react2.default.createElement(_TrackButton2.default, {
              label: 'Seek to a different time in the video',
              onMouseDown: this.onDragStartDurationTrackButton,
              ref: function ref(component) {
                _this2.durationTrackButton = (0, _reactDom.findDOMNode)(component);
              },
              style: durationTrackButtonStyle
            })
          ),
          _react2.default.createElement(
            'div',
            { style: styles.actionsContainer },
            _react2.default.createElement(_Button2.default, {
              onClick: this.onClickPlayPauseButton,
              icon: isPlaying ? _icons.availableIcons.PAUSE : _icons.availableIcons.PLAY,
              label: 'Toggle playing the video',
              style: playPauseButtonStyle
            }),
            _react2.default.createElement(_InformationBar2.default, {
              currentTime: currentTime,
              duration: duration,
              style: informationContainerStyle
            }),
            _react2.default.createElement(
              _Button2.default,
              {
                icon: _icons.availableIcons.FAST_FORWARD,
                onClick: this.onClickFastForward,
                label: 'Increase the playback speed',
                style: fastForwardButtonStyle
              },
              _react2.default.createElement(
                'span',
                { style: styles.speedIdentifier },
                PLAYBACK_SPEEDS[playbackRateIndex],
                'x'
              )
            ),
            _react2.default.createElement(
              _VolumeContainer2.default,
              {
                onMouseEnter: this.onMouseEnterVolumeChange,
                onMouseLeave: this.onMouseLeaveVolumeChange,
                style: styles.volumnChangeContainer
              },
              _react2.default.createElement(_Button2.default, {
                icon: volumeIcon,
                onClick: this.onClickToggleVolumeMuted,
                label: 'Toggle the video being muted',
                style: volumeButtonStyle
              }),
              _react2.default.createElement(
                _Display2.default,
                {
                  onClick: this.onClickVolumeTrack,
                  ref: function ref(component) {
                    _this2.volume = (0, _reactDom.findDOMNode)(component);
                  },
                  style: volumeChangeStyle
                },
                _react2.default.createElement(_Track2.default, {
                  ref: function ref(component) {
                    _this2.volumeTrack = (0, _reactDom.findDOMNode)(component);
                  },
                  style: volumeChangeTrackStyle
                }),
                _react2.default.createElement(_TrackButton2.default, {
                  label: 'Change the volume',
                  onMouseDown: this.onDragStartVolumeTrackButton,
                  ref: function ref(component) {
                    _this2.volumeTrackButton = (0, _reactDom.findDOMNode)(component);
                  },
                  style: volumeTrackButtonStyle
                })
              )
            ),
            canUseFullscreen && _react2.default.createElement(_Button2.default, {
              icon: isFullscreen ? _icons.availableIcons.SHRINK : _icons.availableIcons.EXPAND,
              label: 'Toggle fullscreen mode',
              onClick: this.onClickToggleFullscreen,
              style: fullscreenButtonStyle
            })
          )
        )
      );
    }
  }]);

  return VidzPlayer;
}(_react.Component), _class2.propTypes = {
  autoplay: _react.PropTypes.bool,
  controlsBackgroundColor: _react.PropTypes.string,
  controlsFontColor: _react.PropTypes.string,
  controlsTrackColor: _react.PropTypes.string,
  height: _react.PropTypes.number,
  loop: _react.PropTypes.bool,
  mp4: _react.PropTypes.string,
  muted: _react.PropTypes.bool,
  ogg: _react.PropTypes.string,
  onCanPlay: _react.PropTypes.func,
  onCanPlayType: _react.PropTypes.func,
  onDurationChange: _react.PropTypes.func,
  onEmptied: _react.PropTypes.func,
  onEnded: _react.PropTypes.func,
  onError: _react.PropTypes.func,
  onLoad: _react.PropTypes.func,
  onLoadedData: _react.PropTypes.func,
  onLoadedMetadata: _react.PropTypes.func,
  onLoadStart: _react.PropTypes.func,
  onPause: _react.PropTypes.func,
  onPlay: _react.PropTypes.func,
  onProgress: _react.PropTypes.func,
  onSeeked: _react.PropTypes.func,
  onSeeking: _react.PropTypes.func,
  onStalled: _react.PropTypes.func,
  onSuspend: _react.PropTypes.func,
  onTimeUpdate: _react.PropTypes.func,
  onWaiting: _react.PropTypes.func,
  playOnClick: _react.PropTypes.bool,
  preload: _react.PropTypes.string,
  preventAutoHideControls: _react.PropTypes.bool,
  theme: _react.PropTypes.oneOf(THEMES),
  webm: _react.PropTypes.string,
  width: _react.PropTypes.number
}, _class2.defaultProps = {
  autoplay: false,
  controls: false,
  loop: false,
  muted: false,
  playOnClick: false,
  preventAutoHideControls: false,
  theme: THEMES[0]
}, _temp2)) || _class;

exports.default = VidzPlayer;
module.exports = exports['default'];